// implementation of declaration

#include <sdkddkver.h>
#include <afxwin.h>
#include <afxext.h>
#include <afxcmn.h>
#include "resource.h"
#include "communer.h"
#include "miscellaneous.h"
#include "slider.h"
#include "viewer.h"

IMPLEMENT_DYNCREATE(viewer, CFormView)

BEGIN_MESSAGE_MAP(viewer, CFormView)
    ON_BN_CLICKED(IDC_SAVE, viewer::on_save)
    ON_BN_CLICKED(IDC_RESET, viewer::on_reset)
    ON_WM_VSCROLL()
END_MESSAGE_MAP()

viewer::viewer() : CFormView(viewer::IDD)
{
}

viewer::~viewer()
{
}

void viewer::DoDataExchange(CDataExchange * data)
{
    CFormView::DoDataExchange(data);

    DDX_Control(data, IDC_NAME, m_name);
    DDX_Control(data, IDC_SAVE, m_save);
    DDX_Control(data, IDC_RESET, m_reset);
    DDX_Control(data, IDC_SLIDER_1, m_slider_1);
    DDX_Control(data, IDC_SLIDER_2, m_slider_2);
    DDX_Control(data, IDC_SLIDER_3, m_slider_3);
    DDX_Control(data, IDC_SLIDER_4, m_slider_4);
    DDX_Control(data, IDC_SLIDER_5, m_slider_5);
    DDX_Control(data, IDC_SLIDER_6, m_slider_6);
    DDX_Control(data, IDC_NUMBER_1, m_number_1);
    DDX_Control(data, IDC_NUMBER_2, m_number_2);
    DDX_Control(data, IDC_NUMBER_3, m_number_3);
    DDX_Control(data, IDC_NUMBER_4, m_number_4);
    DDX_Control(data, IDC_NUMBER_5, m_number_5);
    DDX_Control(data, IDC_NUMBER_6, m_number_6);
}

void viewer::OnInitialUpdate()
{
    CFormView::OnInitialUpdate();
    GetParentFrame()->SetMenu(NULL);
    GetParentFrame()->RecalcLayout();
    ResizeParentToFit(FALSE);

    // turn from font-of-edit into font-of-run
    m_font.CreatePointFont(90,"fixedsys"); SetFont(&m_font);
    SendMessageToDescendants(WM_SETFONT,(WPARAM)m_font.m_hObject);

    // fast things before window showed

    m_name.SetWindowText("");

    m_slider_1.SetRange(0,0); m_slider_1.SetPos(0); m_number_1.SetWindowText("");
    m_slider_2.SetRange(0,0); m_slider_2.SetPos(0); m_number_2.SetWindowText("");
    m_slider_3.SetRange(0,0); m_slider_3.SetPos(0); m_number_3.SetWindowText("");
    m_slider_4.SetRange(0,0); m_slider_4.SetPos(0); m_number_4.SetWindowText("");
    m_slider_5.SetRange(0,0); m_slider_5.SetPos(0); m_number_5.SetWindowText("");
    m_slider_6.SetRange(0,0); m_slider_6.SetPos(0); m_number_6.SetWindowText("");
}

void viewer::additional_update()
{
    // slow things after window showed

    init_name();

    init_slider(1);
    init_slider(2);
    init_slider(3);
    init_slider(4);
    init_slider(5);
    init_slider(6);
}

void viewer::init_name()
{
CString string;

    get_name(string);
    m_name.SetWindowText(string);
}

void viewer::init_slider(int index)
{
unsigned long current, maximum;

    current = maximum = 0;

    if (index == 1) get_brightness (current,maximum);
    if (index == 2) get_contrast   (current,maximum);
    if (index == 3) get_sharpness  (current,maximum);
    if (index == 4) get_red        (current,maximum);
    if (index == 5) get_green      (current,maximum);
    if (index == 6) get_blue       (current,maximum);

    if (index == 1) m_slider_1.SetTicFreq(range_to_tic(maximum));
    if (index == 2) m_slider_2.SetTicFreq(range_to_tic(maximum));
    if (index == 3) m_slider_3.SetTicFreq(range_to_tic(maximum));
    if (index == 4) m_slider_4.SetTicFreq(range_to_tic(maximum));
    if (index == 5) m_slider_5.SetTicFreq(range_to_tic(maximum));
    if (index == 6) m_slider_6.SetTicFreq(range_to_tic(maximum));

    if (index == 1) m_slider_1.SetRange(0,maximum);
    if (index == 2) m_slider_2.SetRange(0,maximum);
    if (index == 3) m_slider_3.SetRange(0,maximum);
    if (index == 4) m_slider_4.SetRange(0,maximum);
    if (index == 5) m_slider_5.SetRange(0,maximum);
    if (index == 6) m_slider_6.SetRange(0,maximum);

    if (index == 1) m_slider_1.SetPos(current);
    if (index == 2) m_slider_2.SetPos(current);
    if (index == 3) m_slider_3.SetPos(current);
    if (index == 4) m_slider_4.SetPos(current);
    if (index == 5) m_slider_5.SetPos(current);
    if (index == 6) m_slider_6.SetPos(current);

    if (index == 1) m_number_1.SetWindowText(integer_to_string(current));
    if (index == 2) m_number_2.SetWindowText(integer_to_string(current));
    if (index == 3) m_number_3.SetWindowText(integer_to_string(current));
    if (index == 4) m_number_4.SetWindowText(integer_to_string(current));
    if (index == 5) m_number_5.SetWindowText(integer_to_string(current));
    if (index == 6) m_number_6.SetWindowText(integer_to_string(current));
}

void viewer::emit_slider(int index)
{
unsigned long current, maximum;

    current = maximum = 0;

    if (index == 1) current = m_slider_1.GetPos();
    if (index == 2) current = m_slider_2.GetPos();
    if (index == 3) current = m_slider_3.GetPos();
    if (index == 4) current = m_slider_4.GetPos();
    if (index == 5) current = m_slider_5.GetPos();
    if (index == 6) current = m_slider_6.GetPos();

    if (index == 1) maximum = m_slider_1.GetRangeMax();
    if (index == 2) maximum = m_slider_2.GetRangeMax();
    if (index == 3) maximum = m_slider_3.GetRangeMax();
    if (index == 4) maximum = m_slider_4.GetRangeMax();
    if (index == 5) maximum = m_slider_5.GetRangeMax();
    if (index == 6) maximum = m_slider_6.GetRangeMax();

    if (index == 1) if (maximum) set_brightness (current);
    if (index == 2) if (maximum) set_contrast   (current);
    if (index == 3) if (maximum) set_sharpness  (current);
    if (index == 4) if (maximum) set_red        (current);
    if (index == 5) if (maximum) set_green      (current);
    if (index == 6) if (maximum) set_blue       (current);

    if (index == 1) m_number_1.SetWindowText(integer_to_string(current));
    if (index == 2) m_number_2.SetWindowText(integer_to_string(current));
    if (index == 3) m_number_3.SetWindowText(integer_to_string(current));
    if (index == 4) m_number_4.SetWindowText(integer_to_string(current));
    if (index == 5) m_number_5.SetWindowText(integer_to_string(current));
    if (index == 6) m_number_6.SetWindowText(integer_to_string(current));
}

void viewer::on_save()
{
BOOL status;

    if (MessageBox("It takes about 3 seconds ...","Save",MB_OKCANCEL) != IDOK) return;

    BeginWaitCursor();

    emit_slider(1);
    emit_slider(2);
    emit_slider(3);
    emit_slider(4);
    emit_slider(5);
    emit_slider(6);

    status = save_ddcci(); // let it cover this too for compatibility
    status = save_mccs(); // main job

    EndWaitCursor();

    if (status == FALSE) MessageBox("Failed.","Save");
}

void viewer::on_reset()
{
BOOL status;

    if (MessageBox("It takes about 13 seconds ...","Reset",MB_OKCANCEL) != IDOK) return;

    BeginWaitCursor();

    status = reset_geometry(); // let it cover both analog and digital
    status = reset_all(); // main job

    init_slider(1);
    init_slider(2);
    init_slider(3);
    init_slider(4);
    init_slider(5);
    init_slider(6);

    EndWaitCursor();

    if (status == FALSE) MessageBox("Failed.","Reset");
}

void viewer::OnVScroll(UINT code, UINT position, CScrollBar * bar)
{
    if (code != SB_ENDSCROLL) // defer is nope
    {
     if (bar)
     {
      if (bar->m_hWnd)
      {
       if (bar->m_hWnd == m_slider_1.m_hWnd) emit_slider(1);
       if (bar->m_hWnd == m_slider_2.m_hWnd) emit_slider(2);
       if (bar->m_hWnd == m_slider_3.m_hWnd) emit_slider(3);
       if (bar->m_hWnd == m_slider_4.m_hWnd) emit_slider(4);
       if (bar->m_hWnd == m_slider_5.m_hWnd) emit_slider(5);
       if (bar->m_hWnd == m_slider_6.m_hWnd) emit_slider(6);
      }
     }
    }

    CFormView::OnVScroll(code,position,bar);
}
